Export kalendáře a kontaktů z Google a Microsoftu
Modul 5: Kalendář a kontakty · Doba čtení: 12 minut
Cíl lekce: Po této lekci dokážete vytvořit úplný a použitelný export kalendářů a kontaktů z Google a Microsoftu, přečíst soubor ICS a vCard, a budete vědět, co se při exportu nepřenese nebo přenese jinak.
Klíčové pojmy: iCalendar (ICS), VCALENDAR, VEVENT, UID, DTSTART, RRULE, EXDATE, VTIMEZONE a TZID, ORGANIZER a ATTENDEE, VALARM, vCard (VCF) 3.0 a 4.0, csv, Google Takeout, migrační nástroj
Dva formáty souborů, které zná skoro každý
Kalendáře a kontakty přesouváte pomocí dvou otevřených formátů:
- iCalendar, soubory s příponou
.ics(RFC 5545), pro kalendáře a úkoly. - vCard, soubory s příponou
.vcf, pro kontakty. Existují dvě verze, se kterými se setkáte: 3.0 (RFC 2426) a 4.0 (RFC 6350).
Jde o běžné textové soubory. Můžete je otevřít v textovém editoru, a přesně to v této lekci uděláte. Kdo ví, co v nich je, uvidí i to, co v nich chybí.
Často existuje jednodušší cesta než export: mnoho nových služeb má migrační nástroj, který s Vaším souhlasem přímo stáhne kalendáře a kontakty z Google nebo Microsoftu. Je to rychlejší a s menším počtem chyb. Přesto je vlastní export rozumný: jako kontrola (kolik jsem měl schůzek a kontaktů?), jako záloha předtím, než zrušíte starou službu, a jako záchranná cesta, pokud Vám správce migrační nástroj nepovolí.
Jak vypadá soubor s kalendářem
Export kalendáře pekárny Zrnitost začíná takto:
BEGIN:VCALENDAR
VERSION:2.0
PRODID:-//Google Inc//Google Calendar 70.9054//EN
BEGIN:VTIMEZONE
TZID:Europe/Amsterdam
...
END:VTIMEZONE
BEGIN:VEVENT
UID:3f1a9c2e7b@google.com
DTSTART;TZID=Europe/Amsterdam:20261110T060000
DTEND;TZID=Europe/Amsterdam:20261110T070000
RRULE:FREQ=WEEKLY;BYDAY=TU
EXDATE;TZID=Europe/Amsterdam:20261229T060000
SUMMARY:Levering meel
ORGANIZER:mailto:anne@example.com
ATTENDEE;CN=Groothandel:mailto:verkoop@example.net
BEGIN:VALARM
TRIGGER:-PT30M
ACTION:DISPLAY
END:VALARM
END:VEVENT
END:VCALENDARCo vidíte:
| Řádek | Význam | Kde to může selhat |
|---|---|---|
BEGIN:VCALENDAR a VERSION:2.0 | jde o soubor iCalendar | pokud chybí, import se odmítne |
BEGIN:VEVENT ... END:VEVENT | jedna schůzka | chybějící END znečitelní zbytek souboru |
UID | trvalý identifikátor schůzky | bez UID server nerozpozná duplicity |
DTSTART;TZID=... | čas začátku v konkrétním časovém pásmu | viz časová pásma níže |
RRULE | pravidlo opakování: každé úterý | neplatné pravidlo vytvoří jedinou schůzku místo série |
EXDATE | výjimka: tentokrát ne | |
ORGANIZER, ATTENDEE | kdo pozval a kdo je pozván | viz pozvánky níže |
VALARM | připomenutí, 30 minut předem | ne každá služba připomenutí přebírá |
Časová pásma
Čas s TZID=Europe/Amsterdam znamená: 6 hodin ráno v Amsterdamu, i po přechodu na letní čas. Soubor by proto měl obsahovat i blok VTIMEZONE, který toto časové pásmo popisuje. Exporty z Outlooku často používají názvy pásem podle Windows, například W. Europe Standard Time. To funguje dobře, pokud je k dispozici blok VTIMEZONE. Pokud chybí, nová služba časové pásmo odhaduje a schůzky se Vám posunou o hodinu. Čas končící na Z (20261110T050000Z) je v UTC a je vždy jednoznačný. Čas bez časového pásma a bez Z se nazývá „plovoucí“ čas: platí v časovém pásmu toho, kdo se na něj dívá.
Celodenní události jsou uvedeny jako datum bez času: DTSTART;VALUE=DATE:20261224.
Pozvánky
Schůzka, kterou jste organizovali Vy, je v souboru uvedena s Vámi jako ORGANIZER. Po importu bude ve Vašem novém kalendáři, ale účastníci ji budou mít ve svém kalendáři stále jako pozvánku z Vaší staré adresy, s UID ze staré služby. Pokud schůzku později upravíte, dostanou novou pozvánku. U opakujících se schůzek s externími účastníky může být vhodnější po přechodu pozvat je znovu. Schůzky, na které jste byli pozváni Vy, se přenesou jako běžné schůzky; odpovědi organizátorovi chodí e-mailem.
Export z Google
- Kalendář: v Google Kalendáři, v Nastavení, v části Import a export, tlačítko Export. Získáte zip soubor se souborem ics pro každý kalendář, jehož jste vlastníkem. Kalendáře, které s Vámi sdílejí jiní, v něm nejsou; ty exportuje vlastník, případně je exportujete jednotlivě z nastavení daného kalendáře, pokud je to povoleno.
- Kontakty: v Kontaktech Google vyberete kontakty (nebo všechny), zvolíte Export a poté formát vCard. Google nabízí i „Google CSV“ a „Outlook CSV“; zvolte vCard, protože ten zachová strukturu (více telefonních čísel, adres, fotografii).
- Vše najednou: Google Takeout (takeout.google.com) poskytne kalendář jako ics, kontakty jako vcf (nebo csv) a Gmail jako mbox, v zip souborech. Vhodné jako záloha celého účtu.
Názvy nabídek se čas od času mění; v případě pochybností vyhledejte v nápovědě Google „export kalendáře“.
Export z Microsoftu
- Kalendář: v klasickém Outlooku pro Windows můžete uložit kalendář jako soubor iCalendar (Uložit jako, s výběrem období a volby „plné podrobnosti“). Zvolte období, které jde dostatečně daleko do minulosti i budoucnosti, a zvolte plné podrobnosti, jinak exportujete pouze informaci volno/obsazeno. V Outlooku na webu můžete kalendář publikovat jako odkaz ICS a soubor přes tento odkaz stáhnout; po dokončení publikaci opět vypněte.
- Kontakty: Outlook na webu exportuje kontakty jako csv, nikoli jako vCard. Klasický Outlook exportuje hromadně také do csv; vCard je tam možné jen po jednotlivých kontaktech. Soubor csv neumí mnoho služeb CardDAV přímo importovat. Existují dvě řešení: použít migrační nástroj nové služby (ten stáhne kontakty přímo), nebo csv naimportovat do adresáře v Thunderbirdu a tam jej exportovat jako vCard.
- Sdílené kalendáře a kalendáře místností jsou kalendáře organizace. Ty exportuje správce, nebo je v nové službě znovu vytvoříte.
Co se při exportu nepřenese nebo přenese jinak
| Část | Co se stane |
|---|---|
| Přílohy u schůzek | většinou se nepřenesou; zůstane jen odkaz, nebo nic |
| Barvy a kategorie | někdy jako CATEGORIES, často vůbec |
| Připomenutí | někdy, podle služby |
| Odkazy na videokonference (Teams, Meet) | zůstanou ve schůzce jako text, ale po zrušení předplatného přestanou fungovat |
| Skupiny kontaktů nebo štítky | ne vždy; po importu zkontrolujte |
| Fotografie kontaktů | přenesou se ve vCard, ale zvětší velikost souboru |
Spočítejte si to, než budete pokračovat
Před exportem si poznamenejte, kolik máte kontaktů, a u několika kalendářů, kolik schůzek je v určitém období (například v listopadu). Po importu počítejte znovu. To je nejrychlejší způsob, jak zjistit, že něco chybí. V úkolu této lekce necháte program spočítat a zkontrolovat Vaše soubory.
V praxi: jak to vypadá u poskytovatele
V Nextcloudu WebOké existují dva migrační nástroje, které stahují data přímo: WebOké Import Tool pro Google (Drive, Fotky, Kalendář a Kontakty) a Přenos dat pro OneDrive a Microsoft 365, pomocí kterého naimportujete i kontakty a kalendáře z Vašeho účtu Microsoft. Pokud Váš kalendář pochází odjinud, naimportujete soubory ics a vCard sami (lekce 5.3). Nextcloud umí číst vCard 3.0 i 4.0. U jiných evropských služeb existují podobné importní nástroje nebo tlačítko importu v kalendáři a adresáři; formáty souborů jsou všude stejné.
Shrnutí
- Kalendáře přesouváte jako ics (iCalendar), kontakty jako vcf (vCard 3.0 nebo 4.0); jde o čitelné textové soubory.
- Migrační nástroj, který data stahuje přímo, bývá jednodušší, ale přesto si udělejte vlastní export jako kontrolu a zálohu.
- V souboru ics si všímejte UID, RRULE a časových pásem s blokem VTIMEZONE; bez něj se schůzky posunou.
- Outlook na webu exportuje kontakty pouze jako csv; použijte migrační nástroj, nebo csv převeďte na vCard.
- Předem si spočítejte kontakty a schůzky, abyste po importu poznali, zda něco chybí.
Kvíz
Úkol
Úkol A5.2: Kontrola testovacího exportu. Exportujte kalendář (ics) a své kontakty (vcf). Nejprve vyplňte, kolik máte kontaktů a kolik schůzek očekáváte. Poté soubory nahrajte. Program zkontroluje, zda jsou platné, spočítá schůzky, opakování a kontakty, vyhledá časová pásma bez popisu a duplicitní kontakty a porovná je s Vašimi čísly. Soubory jsou pouze přečteny a nejsou uchovávány.
Úkol E5.2: Co se nepřenese? Otevřete svůj soubor ics v textovém editoru. Najděte opakující se schůzku, schůzku s účastníky a schůzku s odkazem na videokonferenci. U každé schůzky si poznamenejte, co musíte po přechodu udělat.
Úkol E5.2: Co se nepřenese?
Otevřete svůj vlastní soubor ics v textovém editoru.
Vaše zaškrtnutí a poznámky zůstávají pouze v tomto prohlížeči; nikam je neposíláme. Pokud jste přihlášeni, ukládáme v sekci Moje kurzy pouze to, že jste úkol splnili.
Další čtení
Kroky v těchto článcích platí pro služby WebOké; u jiných poskytovatelů to funguje obdobně.
- Příručka k Nextcloud 13.5: Přenos kalendáře a kontaktů ze služeb Google, iCloud nebo Outlook (ics a vCard)
- Příručka k Nextcloud 13.2: Přenos Google Drive, Fotek, Kalendáře a Kontaktů pomocí nástroje WebOké Import Tool
- Příručka k Nextcloud 13.4: OneDrive převést pomocí Migrace dat
- Příručka k Nextcloud 13.6: Z Microsoft 365 do WebOké: soubory, dokumenty, e-mail a kalendář
- RFC 5545 (iCalendar), RFC 2426 (vCard 3.0), RFC 6350 (vCard 4.0)
- Nápověda Google Kalendáře: Export událostí; Nápověda Kontaktů Google: Export kontaktů; Podpora Microsoftu: Export kontaktů z Outlooku
